﻿// Copyright (c) Yoganand R. All rights reserved.
// For continued development and updates, visit http://yogsbreath.com
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommonLibrary
{
    /// <summary>
    /// The enum helps to identify what is the latest state of the entity.
    /// </summary>
    public enum EntityStatus
    {
        /// <summary>
        /// The entity mode is not set.
        /// </summary>
        None = 0,
        /// <summary>
        /// The entity is brand new.
        /// </summary>
        New = 1,
        /// <summary>
        /// Entity is updated. 
        /// </summary>
        Updated = 2,
        /// <summary>
        /// Entity is deleted. 
        /// </summary>
        Deleted = 3
    }
}
