﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.UI;
using System.ComponentModel;

namespace MVCnExt.Web.UI.Ext
{
    [DefaultProperty("Description")]
    [ToolboxData("<{0}:ExtData runat=server></{0}:ExtData>")]
    [ParseChildren(true, "Description")]
    public class ExtData
    {

        [Bindable(true)]
        [Category("Appearance")]
        [DefaultValue("default description")]
        [Localizable(true)]
        [PersistenceMode(PersistenceMode.InnerDefaultProperty)]
        public string Description { get; set; }
    }

    [DefaultProperty("text")]
    [ToolboxData("<{0}:ExtScript runat=server></{0}:ExtScript>")]
    [ParseChildren(true, "text")]
    public class ExtScript
    {

        [Bindable(true)]
        [Category("Appearance")]
        [DefaultValue("default listeners")]
        [Localizable(true)]
        [PersistenceMode(PersistenceMode.InnerDefaultProperty)]
        public string text { get; set; }
    }

    [ToolboxData("<{0}:ExtScript runat=server></{0}:ExtScript>")]
    [ParseChildren(true, "script")]
    public class ExtClientScript
    {

        [Bindable(true)]
        [Category("Appearance")]
        [Localizable(true)]
        [PersistenceMode(PersistenceMode.InnerProperty)]
        public ExtScript script { get; set; }
    }
}
