﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.UI;
using System.Reflection;
using System.Web.UI.WebControls;

namespace MVCnExt.Web.UI.Ext
{
    public abstract class ExtBoxComponent : ExtComponent
    {
        public override IList<ScriptDescriptor> GetScriptDescriptors()
        {
            IList<ScriptDescriptor> list = base.GetScriptDescriptors();

            ScriptControlDescriptorBase desc = (ScriptControlDescriptorBase)list[0];

            desc.Type = "Ext.BoxComponent";

            String[] properties = new String[]{
                "autoHeight", "autoWidth", "height", "pageX", 
                "pageY", "width", "x", "y", "minSize", "maxSize"
            };

            Type component = typeof(ExtBoxComponent);

            foreach (String property in properties)
            {
                PropertyInfo i = component.GetProperty(property);

                if (i == null)
                    throw new InvalidOperationException(String.Format("Property not found, 'ExtJsBoxComponent.{0}'", property));

                Object value = i.GetValue(this, null);

                if (value == null)
                    continue;

                if (!(value is String))
                    desc.AddPropertyBase(property, value);
                else
                    desc.AddPropertyBase(property, String.Format("'{0}'", value));
            }

            return list;
        }

        public Boolean? autoHeight { get; set; }

        public Boolean? autoWidth { get; set; }

        public virtual Unit? height { get; set; }        

        public Int32? pageX { get; set; }

        public Int32? pageY { get; set; }

        public Unit? minSize { get; set; }

        public Unit? maxSize { get; set; }

        public virtual Unit? width { get; set; }

        public Int32? x { get; set; }

        public Int32? y { get; set; }
    }

    public abstract class ExtConfigBoxComponent : ExtConfigComponent
    {
        public override IList<ScriptDescriptor> GetScriptDescriptors()
        {
            IList<ScriptDescriptor> list = base.GetScriptDescriptors();

            ScriptControlDescriptorBase desc = (ScriptControlDescriptorBase)list[0];

            desc.Type = "Ext.BoxComponent";

            String[] properties = new String[]{
                "autoHeight", "autoWidth", "pageX", 
                "pageY", "x", "y", "minSize", "maxSize"
            };

            Type component = typeof(ExtConfigBoxComponent);

            foreach (String property in properties)
            {
                PropertyInfo i = component.GetProperty(property);

                if (i == null)
                    throw new InvalidOperationException(String.Format("Property not found, 'ExtJsBoxComponent.{0}'", property));

                Object value = i.GetValue(this, null);

                if (value == null)
                    continue;

                if (!(value is String))
                    desc.AddPropertyBase(property, value);
                else
                    desc.AddPropertyBase(property, String.Format("'{0}'", value));
            }

            return list;
        }

        public Boolean? autoHeight { get; set; }

        public Boolean? autoWidth { get; set; }

        public virtual String height { get; set; }

        public Int32? pageX { get; set; }

        public Int32? pageY { get; set; }

        public Unit? minSize { get; set; }

        public Unit? maxSize { get; set; }

        public virtual String width { get; set; }

        public Int32? x { get; set; }

        public Int32? y { get; set; }
    }
}
