﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MVCnExt.Web.UI.Ext
{
    public enum DataLoadMode
    {
        Default,
        Remote,
        Local
    }

    public enum TriggerAction
    {
        All,
        Query
    }

    public enum InputType
    {
        Text,
        Password
    }

    public enum ext
    {
        Component,
        Panel,
        TabPanel
    }

    public enum sortDirection
    {
        /// <summary>
        /// Ascending
        /// </summary>
        ASC,

        /// <summary>
        /// Descending
        /// </summary>
        DESC
    }

    /// <summary>
    /// Sort types
    /// </summary>
    public enum sortType
    {
        /// <summary>
        /// Default sort that does nothing
        /// </summary>
        None,

        /// <summary>
        /// Date sorting
        /// </summary>
        AsDate,

        /// <summary>
        /// Float sorting
        /// </summary>
        AsFloat,

        /// <summary>
        /// Integer sorting
        /// </summary>
        AsInt,

        /// <summary>
        /// Strips all HTML tags to sort on text only
        /// </summary>
        AsText,

        /// <summary>
        /// Case insensitive string
        /// </summary>
        AsUCString,

        /// <summary>
        /// Strips all HTML tags to sort on text only - Case insensitive
        /// </summary>
        AsUCText,

        /// <summary>
        /// Custom sorting - use user defined JFunction
        /// </summary>
        Custom
    }

    /// <summary>
    /// The data type for conversion to displayable value
    /// </summary>
    public enum recordType
    {
        /// <summary>
        /// (Default, implies no conversion)
        /// </summary>
        Auto,

        /// <summary>
        /// To string conversion
        /// </summary>
        String,

        /// <summary>
        /// To int conversion
        /// </summary>
        Int,

        /// <summary>
        /// To float conversion
        /// </summary>
        Float,

        /// <summary>
        /// To boolean conversion
        /// </summary>
        Boolean,

        /// <summary>
        /// To date conversion
        /// </summary>
        Date
    }

    public enum httpMethod
    {
        GET,
        POST
    }

    public enum collapseMode
    {
        mini
    }

    /// <summary>
    /// Summary description for Region
    /// </summary>
    public enum region
    {
        north,
        south,
        east,
        west,
        center
    }

    public enum shadow
    {
        sides,
        frame,
        drop
    }

    public enum align
    {
        right,
        left,
        center
    }

    public enum hideMode
    {
        visibility,
        offsets,
        display
    }

    public enum shadowMode
    {
        sides,
        frame,
        drop
    }

    public enum xtype
    {
        box,
        button,
        colorpalette,
        component,
        container,
        cycle,
        dataview,
        datepicker,
        editor,
        editorgrid,
        grid,
        paging,
        panel,
        progress,
        splitbutton,
        tabpanel,
        treepanel,
        viewport,
        window,
        toolbar,
        tbbutton,
        tbfill,
        tbitem,
        tbseparator,
        tbspacer,
        tbsplit,
        tbtext,
        form,
        checkbox,
        combo,
        datefield,
        field,
        fieldset,
        hidden,
        htmleditor,
        numberfield,
        radio,
        textarea,
        textfield,
        timefield,
        trigger,
        portal
    }
}
